/* client.c generated by valac 0.56.2, the Vala compiler
 * generated from client.vala, do not modify */

/*
 * Copyright (C) 2012 Daiki Ueno <ueno@unixuser.org>
 * Copyright (C) 2012 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <libfep-glib/libfep-glib.h>
#include <ibus.h>
#include <stdlib.h>
#include <gio/gio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	PREEDIT_STYLE_OVER_THE_SPOT,
	PREEDIT_STYLE_ROOT,
	PREEDIT_STYLE_DEFAULT = PREEDIT_STYLE_OVER_THE_SPOT
} PreeditStyle;

#define TYPE_PREEDIT_STYLE (preedit_style_get_type ())

#define TYPE_OPTIONS (options_get_type ())
typedef struct _Options Options;

#define TYPE_CLIENT (client_get_type ())
#define CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLIENT, Client))
#define CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLIENT, ClientClass))
#define IS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLIENT))
#define IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLIENT))
#define CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLIENT, ClientClass))

typedef struct _Client Client;
typedef struct _ClientClass ClientClass;
typedef struct _ClientPrivate ClientPrivate;
enum  {
	CLIENT_0_PROPERTY,
	CLIENT_NUM_PROPERTIES
};
static GParamSpec* client_properties[CLIENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_FepGAttribute_free0(var) ((var == NULL) ? NULL : (var = (_vala_FepGAttribute_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))

struct _Options {
	PreeditStyle preedit_style;
};

struct _Client {
	FepGClient parent_instance;
	ClientPrivate * priv;
};

struct _ClientClass {
	FepGClientClass parent_class;
};

struct _ClientPrivate {
	IBusInputContext* context;
	IBusLookupTable* lookup_table;
	gboolean preedit_visible;
	gboolean lookup_table_visible;
	Options opts;
	gchar* preedit;
	FepGAttribute* preedit_attr;
	gchar* status;
	FepGAttribute* status_attr;
};

struct _Block1Data {
	int _ref_count_;
	Client* self;
	IBusBus* bus;
};

static gint Client_private_offset;
static gpointer client_parent_class = NULL;

VALA_EXTERN GType preedit_style_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType options_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Options* options_dup (const Options* self);
VALA_EXTERN void options_free (Options* self);
VALA_EXTERN GType client_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Client, g_object_unref)
static void _vala_FepGAttribute_free (FepGAttribute* self);
static void _client_ibus_commit_text (Client* self,
                               IBusText* text);
static void _client_ibus_show_preedit_text (Client* self);
static FepGAttribute* _vala_FepGAttribute_copy (FepGAttribute* self);
static void _client_ibus_hide_preedit_text (Client* self);
static void client_update_status (Client* self);
static void _client_ibus_update_preedit_text (Client* self,
                                       IBusText* text,
                                       guint cursor_pos,
                                       gboolean visible);
static gboolean _fep_g_attribute_equal (const FepGAttribute * s1,
                                 const FepGAttribute * s2);
static gchar* client_format_indicator (Client* self);
static void _client_ibus_show_lookup_table (Client* self);
static void _client_ibus_hide_lookup_table (Client* self);
static void _client_ibus_update_lookup_table (Client* self,
                                       IBusLookupTable* lookup_table,
                                       gboolean visible);
static void _client_ibus_global_engine_changed (Client* self,
                                         const gchar* name);
static gboolean client_real_filter_key_event (FepGClient* base,
                                       guint keyval,
                                       guint modifiers);
static gboolean client_watch_func (Client* self,
                            GIOChannel* source,
                            GIOCondition condition);
static void client_create_input_context_done (Client* self);
static void __client_ibus_commit_text_ibus_input_context_commit_text (IBusInputContext* _sender,
                                                               IBusText* p0,
                                                               gpointer self);
static void __client_ibus_show_preedit_text_ibus_input_context_show_preedit_text (IBusInputContext* _sender,
                                                                           gpointer self);
static void __client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text (IBusInputContext* _sender,
                                                                           gpointer self);
static void __client_ibus_update_preedit_text_ibus_input_context_update_preedit_text (IBusInputContext* _sender,
                                                                               IBusText* p0,
                                                                               guint p1,
                                                                               gboolean p2,
                                                                               gpointer self);
static void __client_ibus_show_lookup_table_ibus_input_context_show_lookup_table (IBusInputContext* _sender,
                                                                           gpointer self);
static void __client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table (IBusInputContext* _sender,
                                                                           gpointer self);
static void __client_ibus_update_lookup_table_ibus_input_context_update_lookup_table (IBusInputContext* _sender,
                                                                               IBusLookupTable* p0,
                                                                               gboolean p1,
                                                                               gpointer self);
VALA_EXTERN Client* client_new (IBusBus* bus,
                    Options* opts,
                    GError** error);
VALA_EXTERN Client* client_construct (GType object_type,
                          IBusBus* bus,
                          Options* opts,
                          GError** error);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __client_ibus_global_engine_changed_ibus_bus_global_engine_changed (IBusBus* _sender,
                                                                         const gchar* p0,
                                                                         gpointer self);
static void __lambda4_ (Block1Data* _data1_,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda4__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static gboolean _client_watch_func_gio_func (GIOChannel* source,
                                      GIOCondition condition,
                                      gpointer self);
static void client_finalize (GObject * obj);
static GType client_get_type_once (void);

static GType
preedit_style_get_type_once (void)
{
	static const GEnumValue values[] = {{PREEDIT_STYLE_OVER_THE_SPOT, "PREEDIT_STYLE_OVER_THE_SPOT", "over-the-spot"}, {PREEDIT_STYLE_ROOT, "PREEDIT_STYLE_ROOT", "root"}, {PREEDIT_STYLE_DEFAULT, "PREEDIT_STYLE_DEFAULT", "default"}, {0, NULL, NULL}};
	GType preedit_style_type_id;
	preedit_style_type_id = g_enum_register_static ("PreeditStyle", values);
	return preedit_style_type_id;
}

GType
preedit_style_get_type (void)
{
	static volatile gsize preedit_style_type_id__once = 0;
	if (g_once_init_enter (&preedit_style_type_id__once)) {
		GType preedit_style_type_id;
		preedit_style_type_id = preedit_style_get_type_once ();
		g_once_init_leave (&preedit_style_type_id__once, preedit_style_type_id);
	}
	return preedit_style_type_id__once;
}

Options*
options_dup (const Options* self)
{
	Options* dup;
	dup = g_new0 (Options, 1);
	memcpy (dup, self, sizeof (Options));
	return dup;
}

void
options_free (Options* self)
{
	g_free (self);
}

static GType
options_get_type_once (void)
{
	GType options_type_id;
	options_type_id = g_boxed_type_register_static ("Options", (GBoxedCopyFunc) options_dup, (GBoxedFreeFunc) options_free);
	return options_type_id;
}

GType
options_get_type (void)
{
	static volatile gsize options_type_id__once = 0;
	if (g_once_init_enter (&options_type_id__once)) {
		GType options_type_id;
		options_type_id = options_get_type_once ();
		g_once_init_leave (&options_type_id__once, options_type_id);
	}
	return options_type_id__once;
}

static inline gpointer
client_get_instance_private (Client* self)
{
	return G_STRUCT_MEMBER_P (self, Client_private_offset);
}

static void
_vala_FepGAttribute_free (FepGAttribute* self)
{
	g_boxed_free (fep_g_attribute_get_type (), self);
}

static void
_client_ibus_commit_text (Client* self,
                          IBusText* text)
{
	gchar* str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = ibus_text_get_text (text);
	_tmp1_ = g_strdup (_tmp0_);
	str = _tmp1_;
	_tmp2_ = str;
	_tmp3_ = strlen (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ > 0) {
		const gchar* _tmp5_;
		_tmp5_ = str;
		fep_g_client_send_text ((FepGClient*) self, _tmp5_);
	}
	_g_free0 (str);
}

static FepGAttribute*
_vala_FepGAttribute_copy (FepGAttribute* self)
{
	return g_boxed_copy (fep_g_attribute_get_type (), self);
}

static gpointer
__vala_FepGAttribute_copy0 (gpointer self)
{
	return self ? _vala_FepGAttribute_copy (self) : NULL;
}

static void
_client_ibus_show_preedit_text (Client* self)
{
	Options _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->opts;
	if (_tmp0_.preedit_style == PREEDIT_STYLE_ROOT) {
		const gchar* _tmp1_;
		FepGAttribute* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		FepGAttribute* _tmp5_;
		FepGAttribute* _tmp6_;
		_tmp1_ = self->priv->preedit;
		_tmp2_ = self->priv->preedit_attr;
		fep_g_client_set_status_text ((FepGClient*) self, _tmp1_, _tmp2_);
		_tmp3_ = self->priv->preedit;
		_tmp4_ = g_strdup (_tmp3_);
		_g_free0 (self->priv->status);
		self->priv->status = _tmp4_;
		_tmp5_ = self->priv->preedit_attr;
		_tmp6_ = __vala_FepGAttribute_copy0 (_tmp5_);
		__vala_FepGAttribute_free0 (self->priv->status_attr);
		self->priv->status_attr = _tmp6_;
	} else {
		const gchar* _tmp7_;
		FepGAttribute* _tmp8_;
		_tmp7_ = self->priv->preedit;
		_tmp8_ = self->priv->preedit_attr;
		fep_g_client_set_cursor_text ((FepGClient*) self, _tmp7_, _tmp8_);
	}
	self->priv->preedit_visible = TRUE;
}

static void
_client_ibus_hide_preedit_text (Client* self)
{
	Options _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->opts;
	if (_tmp0_.preedit_style == PREEDIT_STYLE_ROOT) {
		client_update_status (self);
	} else {
		fep_g_client_set_cursor_text ((FepGClient*) self, "", NULL);
	}
	self->priv->preedit_visible = FALSE;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
_fep_g_attribute_equal (const FepGAttribute * s1,
                        const FepGAttribute * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->type != s2->type) {
		return FALSE;
	}
	if (s1->value != s2->value) {
		return FALSE;
	}
	if (s1->start_index != s2->start_index) {
		return FALSE;
	}
	if (s1->end_index != s2->end_index) {
		return FALSE;
	}
	return TRUE;
}

static void
_client_ibus_update_preedit_text (Client* self,
                                  IBusText* text,
                                  guint cursor_pos,
                                  gboolean visible)
{
	gchar* _preedit = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	IBusAttrList* attrs = NULL;
	IBusAttrList* _tmp2_;
	IBusAttrList* _tmp3_;
	FepGAttribute* attr = NULL;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = ibus_text_get_text (text);
	_tmp1_ = g_strdup (_tmp0_);
	_preedit = _tmp1_;
	_tmp2_ = ibus_text_get_attributes (text);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	attrs = _tmp3_;
	attr = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				IBusAttrList* _tmp6_;
				GArray* _tmp7_;
				IBusAttribute* _attr = NULL;
				IBusAttrList* _tmp8_;
				IBusAttribute* _tmp9_;
				IBusAttribute* _tmp10_;
				IBusAttribute* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = attrs;
				_tmp7_ = _tmp6_->attributes;
				if (!(((guint) i) < _tmp7_->len)) {
					break;
				}
				_tmp8_ = attrs;
				_tmp9_ = ibus_attr_list_get (_tmp8_, (guint) i);
				_tmp10_ = _g_object_ref0 (_tmp9_);
				_attr = _tmp10_;
				_tmp11_ = _attr;
				if (_tmp11_->type == ((guint) IBUS_ATTR_TYPE_UNDERLINE)) {
					IBusAttribute* _tmp12_;
					IBusAttribute* _tmp13_;
					FepGAttribute _tmp14_ = {0};
					FepGAttribute* _tmp15_;
					_tmp12_ = _attr;
					_tmp13_ = _attr;
					memset (&_tmp14_, 0, sizeof (FepGAttribute));
					_tmp14_.type = FEP_G_ATTR_TYPE_UNDERLINE;
					_tmp14_.value = (guint) FEP_G_ATTR_UNDERLINE_SINGLE;
					_tmp14_.start_index = _tmp12_->start_index;
					_tmp14_.end_index = _tmp13_->end_index;
					_tmp15_ = __vala_FepGAttribute_copy0 (&_tmp14_);
					__vala_FepGAttribute_free0 (attr);
					attr = _tmp15_;
				}
				_g_object_unref0 (_attr);
			}
		}
	}
	_tmp18_ = self->priv->preedit;
	_tmp19_ = _preedit;
	if (g_strcmp0 (_tmp18_, _tmp19_) != 0) {
		_tmp17_ = TRUE;
	} else {
		FepGAttribute* _tmp20_;
		FepGAttribute* _tmp21_;
		_tmp20_ = self->priv->preedit_attr;
		_tmp21_ = attr;
		_tmp17_ = _fep_g_attribute_equal (_tmp20_, _tmp21_) != TRUE;
	}
	if (_tmp17_) {
		_tmp16_ = TRUE;
	} else {
		_tmp16_ = self->priv->preedit_visible != visible;
	}
	if (_tmp16_) {
		const gchar* _tmp22_;
		gchar* _tmp23_;
		FepGAttribute* _tmp24_;
		FepGAttribute* _tmp25_;
		_tmp22_ = _preedit;
		_tmp23_ = g_strdup (_tmp22_);
		_g_free0 (self->priv->preedit);
		self->priv->preedit = _tmp23_;
		_tmp24_ = attr;
		_tmp25_ = __vala_FepGAttribute_copy0 (_tmp24_);
		__vala_FepGAttribute_free0 (self->priv->preedit_attr);
		self->priv->preedit_attr = _tmp25_;
		if (visible) {
			_client_ibus_show_preedit_text (self);
		} else {
			_client_ibus_hide_preedit_text (self);
		}
	}
	__vala_FepGAttribute_free0 (attr);
	_g_object_unref0 (attrs);
	_g_free0 (_preedit);
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static gchar*
client_format_indicator (Client* self)
{
	IBusEngineDesc* desc = NULL;
	IBusInputContext* _tmp0_;
	IBusEngineDesc* _tmp1_;
	IBusEngineDesc* _tmp2_;
	IBusEngineDesc* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = ibus_input_context_get_engine (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	desc = _tmp2_;
	_tmp3_ = desc;
	if (_tmp3_ != NULL) {
		gchar* symbol = NULL;
		IBusEngineDesc* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		_tmp4_ = desc;
		_tmp5_ = ibus_engine_desc_get_symbol (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strdup (_tmp6_);
		symbol = _tmp7_;
		_tmp8_ = symbol;
		_tmp9_ = strlen (_tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp10_ == 0) {
			IBusEngineDesc* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			_tmp11_ = desc;
			_tmp12_ = ibus_engine_desc_get_name (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_utf8_strup (_tmp13_, (gssize) -1);
			_tmp15_ = _tmp14_;
			_tmp16_ = g_strconcat (_tmp15_, "??", NULL);
			_tmp17_ = _tmp16_;
			_tmp18_ = string_substring (_tmp17_, (glong) 0, (glong) 2);
			_g_free0 (symbol);
			symbol = _tmp18_;
			_g_free0 (_tmp17_);
			_g_free0 (_tmp15_);
		}
		_tmp19_ = symbol;
		_tmp20_ = g_strconcat ("[", _tmp19_, NULL);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strconcat (_tmp21_, "] ", NULL);
		_tmp23_ = _tmp22_;
		_g_free0 (_tmp21_);
		result = _tmp23_;
		_g_free0 (symbol);
		_g_object_unref0 (desc);
		return result;
	} else {
		gchar* _tmp24_;
		_tmp24_ = g_strdup ("[??] ");
		result = _tmp24_;
		_g_object_unref0 (desc);
		return result;
	}
}

static void
client_update_status (Client* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	FepGAttribute* attr = NULL;
	gboolean _tmp39_ = FALSE;
	const gchar* _tmp40_;
	GString* _tmp41_;
	const gchar* _tmp42_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	_tmp1_ = builder;
	_tmp2_ = client_format_indicator (self);
	_tmp3_ = _tmp2_;
	g_string_append (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	attr = NULL;
	if (self->priv->lookup_table_visible) {
		guint pages = 0U;
		IBusLookupTable* _tmp4_;
		IBusLookupTable* _tmp5_;
		guint start = 0U;
		IBusLookupTable* _tmp6_;
		guint end = 0U;
		IBusLookupTable* _tmp7_;
		IBusLookupTable* _tmp8_;
		_tmp4_ = self->priv->lookup_table;
		_tmp5_ = self->priv->lookup_table;
		pages = _tmp4_->cursor_pos / _tmp5_->page_size;
		_tmp6_ = self->priv->lookup_table;
		start = pages * _tmp6_->page_size;
		_tmp7_ = self->priv->lookup_table;
		_tmp8_ = self->priv->lookup_table;
		end = MIN (start + _tmp7_->page_size, ibus_lookup_table_get_number_of_candidates (_tmp8_));
		{
			guint index = 0U;
			index = start;
			{
				gboolean _tmp9_ = FALSE;
				_tmp9_ = TRUE;
				while (TRUE) {
					IBusText* label = NULL;
					IBusLookupTable* _tmp11_;
					IBusText* _tmp12_;
					IBusText* _tmp13_;
					IBusText* candidate = NULL;
					IBusLookupTable* _tmp14_;
					IBusText* _tmp15_;
					IBusText* _tmp16_;
					gchar* _tmp17_ = NULL;
					IBusText* _tmp18_;
					gchar* label_text = NULL;
					gchar* _tmp23_;
					gchar* text = NULL;
					const gchar* _tmp24_;
					IBusText* _tmp25_;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					gboolean _tmp28_ = FALSE;
					IBusLookupTable* _tmp29_;
					GString* _tmp36_;
					const gchar* _tmp37_;
					if (!_tmp9_) {
						guint _tmp10_;
						_tmp10_ = index;
						index = _tmp10_ + 1;
					}
					_tmp9_ = FALSE;
					if (!(index < end)) {
						break;
					}
					_tmp11_ = self->priv->lookup_table;
					_tmp12_ = ibus_lookup_table_get_label (_tmp11_, index - start);
					_tmp13_ = _g_object_ref0 (_tmp12_);
					label = _tmp13_;
					_tmp14_ = self->priv->lookup_table;
					_tmp15_ = ibus_lookup_table_get_candidate (_tmp14_, index);
					_tmp16_ = _g_object_ref0 (_tmp15_);
					candidate = _tmp16_;
					_tmp18_ = label;
					if (_tmp18_ != NULL) {
						IBusText* _tmp19_;
						const gchar* _tmp20_;
						gchar* _tmp21_;
						_tmp19_ = label;
						_tmp20_ = ibus_text_get_text (_tmp19_);
						_tmp21_ = g_strdup (_tmp20_);
						_g_free0 (_tmp17_);
						_tmp17_ = _tmp21_;
					} else {
						gchar* _tmp22_;
						_tmp22_ = g_strdup_printf ("%u", (index - start) + 1);
						_g_free0 (_tmp17_);
						_tmp17_ = _tmp22_;
					}
					_tmp23_ = g_strdup (_tmp17_);
					label_text = _tmp23_;
					_tmp24_ = label_text;
					_tmp25_ = candidate;
					_tmp26_ = ibus_text_get_text (_tmp25_);
					_tmp27_ = g_strdup_printf ("%s:%s", _tmp24_, _tmp26_);
					text = _tmp27_;
					_tmp29_ = self->priv->lookup_table;
					if (ibus_lookup_table_is_cursor_visible (_tmp29_)) {
						IBusLookupTable* _tmp30_;
						_tmp30_ = self->priv->lookup_table;
						_tmp28_ = index == ibus_lookup_table_get_cursor_pos (_tmp30_);
					} else {
						_tmp28_ = FALSE;
					}
					if (_tmp28_) {
						gint start_index = 0;
						GString* _tmp31_;
						const gchar* _tmp32_;
						const gchar* _tmp33_;
						FepGAttribute _tmp34_ = {0};
						FepGAttribute* _tmp35_;
						_tmp31_ = builder;
						_tmp32_ = _tmp31_->str;
						start_index = g_utf8_strlen (_tmp32_, (gssize) -1);
						_tmp33_ = text;
						memset (&_tmp34_, 0, sizeof (FepGAttribute));
						_tmp34_.type = FEP_G_ATTR_TYPE_STANDOUT;
						_tmp34_.value = (guint) 1;
						_tmp34_.start_index = (guint) start_index;
						_tmp34_.end_index = (guint) (start_index + g_utf8_strlen (_tmp33_, (gssize) -1));
						_tmp35_ = __vala_FepGAttribute_copy0 (&_tmp34_);
						__vala_FepGAttribute_free0 (attr);
						attr = _tmp35_;
					}
					_tmp36_ = builder;
					_tmp37_ = text;
					g_string_append (_tmp36_, _tmp37_);
					if (index < (end - 1)) {
						GString* _tmp38_;
						_tmp38_ = builder;
						g_string_append_c (_tmp38_, ' ');
					}
					_g_free0 (text);
					_g_free0 (label_text);
					_g_free0 (_tmp17_);
					_g_object_unref0 (candidate);
					_g_object_unref0 (label);
				}
			}
		}
	}
	_tmp40_ = self->priv->status;
	_tmp41_ = builder;
	_tmp42_ = _tmp41_->str;
	if (g_strcmp0 (_tmp40_, _tmp42_) != 0) {
		_tmp39_ = TRUE;
	} else {
		FepGAttribute* _tmp43_;
		FepGAttribute* _tmp44_;
		_tmp43_ = self->priv->status_attr;
		_tmp44_ = attr;
		_tmp39_ = _fep_g_attribute_equal (_tmp43_, _tmp44_) != TRUE;
	}
	if (_tmp39_) {
		GString* _tmp45_;
		const gchar* _tmp46_;
		FepGAttribute* _tmp47_;
		GString* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		FepGAttribute* _tmp51_;
		FepGAttribute* _tmp52_;
		_tmp45_ = builder;
		_tmp46_ = _tmp45_->str;
		_tmp47_ = attr;
		fep_g_client_set_status_text ((FepGClient*) self, _tmp46_, _tmp47_);
		_tmp48_ = builder;
		_tmp49_ = _tmp48_->str;
		_tmp50_ = g_strdup (_tmp49_);
		_g_free0 (self->priv->status);
		self->priv->status = _tmp50_;
		_tmp51_ = attr;
		_tmp52_ = __vala_FepGAttribute_copy0 (_tmp51_);
		__vala_FepGAttribute_free0 (self->priv->status_attr);
		self->priv->status_attr = _tmp52_;
	}
	__vala_FepGAttribute_free0 (attr);
	_g_string_free0 (builder);
}

static void
_client_ibus_show_lookup_table (Client* self)
{
	g_return_if_fail (self != NULL);
	self->priv->lookup_table_visible = TRUE;
	client_update_status (self);
}

static void
_client_ibus_hide_lookup_table (Client* self)
{
	gboolean _tmp0_ = FALSE;
	Options _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->lookup_table_visible = FALSE;
	_tmp1_ = self->priv->opts;
	if (_tmp1_.preedit_style == PREEDIT_STYLE_ROOT) {
		_tmp0_ = self->priv->preedit_visible;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		_client_ibus_show_preedit_text (self);
	} else {
		client_update_status (self);
	}
}

static void
_client_ibus_update_lookup_table (Client* self,
                                  IBusLookupTable* lookup_table,
                                  gboolean visible)
{
	IBusLookupTable* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (lookup_table != NULL);
	_tmp0_ = _g_object_ref0 (lookup_table);
	_g_object_unref0 (self->priv->lookup_table);
	self->priv->lookup_table = _tmp0_;
	if (visible) {
		_client_ibus_show_lookup_table (self);
	} else {
		_client_ibus_hide_lookup_table (self);
	}
}

static void
_client_ibus_global_engine_changed (Client* self,
                                    const gchar* name)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	client_update_status (self);
}

static gboolean
client_real_filter_key_event (FepGClient* base,
                              guint keyval,
                              guint modifiers)
{
	Client * self;
	IBusInputContext* _tmp0_;
	gboolean result;
	self = (Client*) base;
	_tmp0_ = self->priv->context;
	if (_tmp0_ != NULL) {
		gboolean retval = FALSE;
		IBusInputContext* _tmp1_;
		_tmp1_ = self->priv->context;
		retval = ibus_input_context_process_key_event (_tmp1_, (guint32) keyval, (guint32) 0, (guint32) modifiers);
		if (retval) {
			client_update_status (self);
		}
		result = retval;
		return result;
	}
	result = FALSE;
	return result;
}

static gboolean
client_watch_func (Client* self,
                   GIOChannel* source,
                   GIOCondition condition)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	fep_g_client_dispatch ((FepGClient*) self);
	result = TRUE;
	return result;
}

static void
__client_ibus_commit_text_ibus_input_context_commit_text (IBusInputContext* _sender,
                                                          IBusText* p0,
                                                          gpointer self)
{
	_client_ibus_commit_text ((Client*) self, p0);
}

static void
__client_ibus_show_preedit_text_ibus_input_context_show_preedit_text (IBusInputContext* _sender,
                                                                      gpointer self)
{
	_client_ibus_show_preedit_text ((Client*) self);
}

static void
__client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text (IBusInputContext* _sender,
                                                                      gpointer self)
{
	_client_ibus_hide_preedit_text ((Client*) self);
}

static void
__client_ibus_update_preedit_text_ibus_input_context_update_preedit_text (IBusInputContext* _sender,
                                                                          IBusText* p0,
                                                                          guint p1,
                                                                          gboolean p2,
                                                                          gpointer self)
{
	_client_ibus_update_preedit_text ((Client*) self, p0, p1, p2);
}

static void
__client_ibus_show_lookup_table_ibus_input_context_show_lookup_table (IBusInputContext* _sender,
                                                                      gpointer self)
{
	_client_ibus_show_lookup_table ((Client*) self);
}

static void
__client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table (IBusInputContext* _sender,
                                                                      gpointer self)
{
	_client_ibus_hide_lookup_table ((Client*) self);
}

static void
__client_ibus_update_lookup_table_ibus_input_context_update_lookup_table (IBusInputContext* _sender,
                                                                          IBusLookupTable* p0,
                                                                          gboolean p1,
                                                                          gpointer self)
{
	_client_ibus_update_lookup_table ((Client*) self, p0, p1);
}

static void
client_create_input_context_done (Client* self)
{
	IBusInputContext* _tmp0_;
	IBusInputContext* _tmp1_;
	IBusInputContext* _tmp2_;
	IBusInputContext* _tmp3_;
	IBusInputContext* _tmp4_;
	IBusInputContext* _tmp5_;
	IBusInputContext* _tmp6_;
	IBusInputContext* _tmp7_;
	IBusInputContext* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	g_signal_connect_object (_tmp0_, "commit-text", (GCallback) __client_ibus_commit_text_ibus_input_context_commit_text, self, 0);
	_tmp1_ = self->priv->context;
	g_signal_connect_object (_tmp1_, "show-preedit-text", (GCallback) __client_ibus_show_preedit_text_ibus_input_context_show_preedit_text, self, 0);
	_tmp2_ = self->priv->context;
	g_signal_connect_object (_tmp2_, "hide-preedit-text", (GCallback) __client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text, self, 0);
	_tmp3_ = self->priv->context;
	g_signal_connect_object (_tmp3_, "update-preedit-text", (GCallback) __client_ibus_update_preedit_text_ibus_input_context_update_preedit_text, self, 0);
	_tmp4_ = self->priv->context;
	g_signal_connect_object (_tmp4_, "show-lookup-table", (GCallback) __client_ibus_show_lookup_table_ibus_input_context_show_lookup_table, self, 0);
	_tmp5_ = self->priv->context;
	g_signal_connect_object (_tmp5_, "hide-lookup-table", (GCallback) __client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table, self, 0);
	_tmp6_ = self->priv->context;
	g_signal_connect_object (_tmp6_, "update-lookup-table", (GCallback) __client_ibus_update_lookup_table_ibus_input_context_update_lookup_table, self, 0);
	_tmp7_ = self->priv->context;
	ibus_input_context_set_capabilities (_tmp7_, (guint32) (((IBUS_CAP_PREEDIT_TEXT | IBUS_CAP_LOOKUP_TABLE) | IBUS_CAP_AUXILIARY_TEXT) | IBUS_CAP_FOCUS));
	_tmp8_ = self->priv->context;
	ibus_input_context_focus_in (_tmp8_);
	client_update_status (self);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		Client* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->bus);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__client_ibus_global_engine_changed_ibus_bus_global_engine_changed (IBusBus* _sender,
                                                                    const gchar* p0,
                                                                    gpointer self)
{
	_client_ibus_global_engine_changed ((Client*) self, p0);
}

static void
__lambda4_ (Block1Data* _data1_,
            GObject* obj,
            GAsyncResult* res)
{
	Client* self;
	GError* _inner_error0_ = NULL;
	self = _data1_->self;
	g_return_if_fail (res != NULL);
	{
		IBusInputContext* _tmp0_ = NULL;
		IBusInputContext* _tmp1_;
		IBusInputContext* _tmp2_;
		_tmp1_ = ibus_bus_create_input_context_async_finish (_data1_->bus, res, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->context);
		self->priv->context = _tmp2_;
		client_create_input_context_done (self);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("client.vala:263: can't create input context: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda4__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
	__lambda4_ (self, source_object, res);
	block1_data_unref (self);
}

static gboolean
_client_watch_func_gio_func (GIOChannel* source,
                             GIOCondition condition,
                             gpointer self)
{
	gboolean result;
	result = client_watch_func ((Client*) self, source, condition);
	return result;
}

Client*
client_construct (GType object_type,
                  IBusBus* bus,
                  Options* opts,
                  GError** error)
{
	Client * self = NULL;
	Block1Data* _data1_;
	IBusBus* _tmp0_;
	Options _tmp1_;
	GIOChannel* channel = NULL;
	GIOChannel* _tmp2_;
	GIOChannel* _tmp3_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (bus != NULL, NULL);
	g_return_val_if_fail (opts != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (bus);
	_g_object_unref0 (_data1_->bus);
	_data1_->bus = _tmp0_;
	self = (Client*) g_object_new (object_type, "address", NULL, NULL);
	_data1_->self = g_object_ref (self);
	g_initable_init ((GInitable*) self, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		_g_object_unref0 (self);
		return NULL;
	}
	_tmp1_ = *opts;
	self->priv->opts = _tmp1_;
	g_signal_connect_object (_data1_->bus, "global-engine-changed", (GCallback) __client_ibus_global_engine_changed_ibus_bus_global_engine_changed, self, 0);
	ibus_bus_create_input_context_async (_data1_->bus, "ibus-fep", -1, NULL, ___lambda4__gasync_ready_callback, block1_data_ref (_data1_));
	_tmp2_ = g_io_channel_unix_new (fep_g_client_get_poll_fd ((FepGClient*) self));
	channel = _tmp2_;
	_tmp3_ = channel;
	g_io_add_watch (_tmp3_, G_IO_IN, _client_watch_func_gio_func, self);
	_g_io_channel_unref0 (channel);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return self;
}

Client*
client_new (IBusBus* bus,
            Options* opts,
            GError** error)
{
	return client_construct (TYPE_CLIENT, bus, opts, error);
}

static void
client_class_init (ClientClass * klass,
                   gpointer klass_data)
{
	client_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Client_private_offset);
	((FepGClientClass *) klass)->filter_key_event = (gboolean (*) (FepGClient*, guint, guint)) client_real_filter_key_event;
	G_OBJECT_CLASS (klass)->finalize = client_finalize;
}

static void
client_instance_init (Client * self,
                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = client_get_instance_private (self);
	self->priv->context = NULL;
	self->priv->preedit_visible = FALSE;
	self->priv->lookup_table_visible = FALSE;
	_tmp0_ = g_strdup ("");
	self->priv->preedit = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->status = _tmp1_;
}

static void
client_finalize (GObject * obj)
{
	Client * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLIENT, Client);
	_g_object_unref0 (self->priv->context);
	_g_object_unref0 (self->priv->lookup_table);
	_g_free0 (self->priv->preedit);
	__vala_FepGAttribute_free0 (self->priv->preedit_attr);
	_g_free0 (self->priv->status);
	__vala_FepGAttribute_free0 (self->priv->status_attr);
	G_OBJECT_CLASS (client_parent_class)->finalize (obj);
}

static GType
client_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Client), 0, (GInstanceInitFunc) client_instance_init, NULL };
	GType client_type_id;
	client_type_id = g_type_register_static (fep_g_client_get_type (), "Client", &g_define_type_info, 0);
	Client_private_offset = g_type_add_instance_private (client_type_id, sizeof (ClientPrivate));
	return client_type_id;
}

GType
client_get_type (void)
{
	static volatile gsize client_type_id__once = 0;
	if (g_once_init_enter (&client_type_id__once)) {
		GType client_type_id;
		client_type_id = client_get_type_once ();
		g_once_init_leave (&client_type_id__once, client_type_id);
	}
	return client_type_id__once;
}

